<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2018-06-07 Thu 14:59 -->
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Practical Ontology Pattern Instantiation, Discovery, and Maintanence with Reasonable Ontology Templates</title>
<meta name="generator" content="Org mode" />
<meta name="author" content="Martin G. Skjæveland" />
<link rel="stylesheet" type="text/css" href="https://www.ottr.xyz/inc/style.css" />
<link rel="stylesheet" type="text/css" href="https://www.ottr.xyz/inc/spec.css" />
<script type="application/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
<script type="application/javascript" src="https://www.ottr.xyz/inc/toc.js"></script>
</head>
<body>
<div id="content">
<header>
<h1 class="title">Practical Ontology Pattern Instantiation, Discovery, and Maintanence with Reasonable Ontology Templates</h1>
</header><div id="left">
<p>
  <a href="#top">top</a>
  <br/>
  examples:
  <span class="button" onclick="$('.examplebox').show()">show</span>
  /
  <span class="button" onclick="$('.examplebox').hide()">hide</span>
</p>
  <h4>Table of Contents</h4>
  <div id="toc"></div>
</div>

<div id="right">
  <a name="top"></a>
  <h1 class="title">Practical Ontology Pattern Instantiation, Discovery, and Maintanence with Reasonable Ontology Templates</h1>
  <img id="logo" alt="OTTR" src="https://www.ottr.xyz/logo/demOTTR.png"/>
  <p><b>
    Online companion demonstration to ISWC 2018 paper.
  </b></p>

  <p class="notice">The concepts used in this demo are still valid,
      however, tools and formats have been updated. Please
      see <a href="http://ottr.xyz">ottr.xyz</a>.
  </p>


<div id="toc-content">

<div id="outline-container-org16cd095" class="outline-2">
<h2 id="org16cd095"><span class="section-number-2">1</span> Introduction</h2>
<div class="outline-text-2" id="text-1">
<p>
The demo will show how templates and instances are specifies - using
different formats, the result of their expansion, and how templates
may be analysed for different imperfections.
</p>

<p>
The source of this demo is available at the open git repository
<a href="https://gitlab.com/ottr/pub/iswc2018-demo">https://gitlab.com/ottr/pub/iswc2018-demo</a>. It contains:
</p>
<ul class="org-ul">
<li>the OTTR templates and OTTR template instances found on this page</li>
<li>a script that
<ul class="org-ul">
<li>downloads the Java jar executables necessary to run the demo locally</li>
<li>executes all the executable examples found on this page</li>
</ul></li>
<li>this page</li>
<li>the org-mode source file for all the above</li>
</ul>
</div>

<div id="outline-container-org1be0ad7" class="outline-3">
<h3 id="org1be0ad7"><span class="section-number-3">1.1</span> OTTR Serialisations</h3>
<div class="outline-text-3" id="text-1-1">
<p>
In this demonstration we will show OTTR templates and instances
using different serialisations:
</p>

<ul class="org-ul">
<li>stOTTR</li>
<li>wOTTR</li>
<li>tabOTTR</li>
</ul>
</div>

<div id="outline-container-orgb3d5b94" class="outline-4">
<h4 id="orgb3d5b94"><span class="section-number-4">1.1.1</span> stOTTR</h4>
<div class="outline-text-4" id="text-1-1-1">
<p>
stOTTR is a compact way of representing templates and instances
that is also easy to read and write.  A BNF specification of the
language is available at
<a href="https://gitlab.com/ottr/language/stOTTR/blob/master/stOTTR-BNF.md">https://gitlab.com/ottr/language/stOTTR/blob/master/stOTTR-BNF.md</a>
</p>
</div>
</div>

<div id="outline-container-org063ffb8" class="outline-4">
<h4 id="org063ffb8"><span class="section-number-4">1.1.2</span> wOTTR</h4>
<div class="outline-text-4" id="text-1-1-2">
<p>
To enable truly practical use of OTTR for OWL ontology engineering,
we have developed a special-purpose RDF/OWL vocabulary, called
<i>wOTTR</i>, with which OTTR templates can be formulated. This has the
benefit that we can leverage the existing stack of W3C languages
and tools for developing, publishing, and maintaining templates.
The wOTTR format supports writing Triple Template instances as
regular RDF triples. This means that a pattern represented by an
RDF graph or RDF/OWL ontology can easily be turned into an OTTR
template by simply specifying the name of the template and its
parameters with the wOTTR vocabulary.  Furthermore, this means that
we can make use of existing ontology editors and reasoners to
construct and verify the soundness of templates.  The wOTTR
representation has been developed to closely resemble stOTTR. It
uses RDF resources to represent parameters and arguments, and RDF
lists (which have a convenient formatting in Turtle syntax) for
lists of parameters and arguments.  The vocabulary is published at
<a href="http://ns.ottr.xyz/">http://ns.ottr.xyz/</a>.
</p>
</div>
</div>

<div id="outline-container-org9ef92b7" class="outline-4">
<h4 id="org9ef92b7"><span class="section-number-4">1.1.3</span> tabOTTR</h4>
<div class="outline-text-4" id="text-1-1-3">
<p>
tabOTTR is developed particularly for representing large sets
template instances in tabular formats such as spreadsheets, and is
intended for domain expert use.  A specification of tabOTTR is
available at <a href="https://gitlab.com/ottr/language/tabOTTR/builds/artifacts/develop/file/tabOTTR.html?job=build-job">https://gitlab.com/ottr/language/tabOTTR/builds/artifacts/develop/file/tabOTTR.html?job=build-job</a>
</p>
</div>
</div>
</div>

<div id="outline-container-org07b9c54" class="outline-3">
<h3 id="org07b9c54"><span class="section-number-3">1.2</span> OTTR library and online web application</h3>
<div class="outline-text-3" id="text-1-2">
<p>
The "official" OTTR template repository at <a href="http://library.ottr.xyz/">http://library.ottr.xyz/</a>
contains OTTR templates for expressing common RDF, RDFS and OWL
patterns, including other example templates.
</p>

<p>
These templates are conveniently presented in an online library
that is linked to the online web application
</p>

<p>
The web application displays the template, including visualisations
of the pattern, links to dependant templates, and different formats
which are generated from the template (some are experimental):
</p>
<ul class="org-ul">
<li>different expansions</li>
<li>SPARQL queries (SELECT, CONSTRUCT, UPDATE)</li>
<li>XSD+SAWSDL format</li>
<li>XML sample</li>
</ul>
</div>
</div>

<div id="outline-container-orgaf42908" class="outline-3">
<h3 id="orgaf42908"><span class="section-number-3">1.3</span> Prefixes</h3>
<div class="outline-text-3" id="text-1-3">
<p>
In all the example code blocks the following prefixes are used.
</p>

<div class="org-src-container">
<pre class="src src-n3" id="orgb2b2a71">### standard
@prefix rdf:  &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .
@prefix owl:  &lt;http://www.w3.org/2002/07/owl#&gt; .
@prefix xsd:  &lt;http://www.w3.org/2001/XMLSchema#&gt; .
@prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .

### ottr prefixes:
@prefix ottr: &lt;http://ns.ottr.xyz/templates#&gt; .

@prefix t-owl-axiom: &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix t-owl-rstr: &lt;http://candidate.ottr.xyz/owl/restriction/&gt; .

### examples:
@prefix x1:     &lt;http://candidate.ottr.xyz/owl/axiom/SubClassOf#&gt; .
@prefix x2:     &lt;http://candidate.ottr.xyz/rdfs/ResourceDescription#&gt; .

@prefix ex:     &lt;http://example.org#&gt; .
</pre>
</div>
</div>
</div>
</div>


<div id="outline-container-orgd036464" class="outline-2">
<h2 id="orgd036464"><span class="section-number-2">2</span> Templates and Instances</h2>
<div class="outline-text-2" id="text-2">
<p>
An OTTR template consists of a head and a body.  The body represents
a parameterised ontology pattern, and the head specifies the
template's name and its parameters.
</p>

<p>
A template instance consists of a template name and a list of
arguments that matches the parameters of the designated template, and
represents a replica of the template's body pattern where parameters
are replaced by the instance's arguments.
</p>

<p>
The template body comprises only template instances, i.e., the
template pattern is recursively built up from other templates, under
the constraint that cyclic template dependencies are not allowed.
</p>

<p>
There is one special base template, the Triple template, which takes
three arguments.  This template has no body but represents a single
RDF triple in the obvious way.
</p>

<p>
Expanding an instance is the process of recursively replacing
instances with the pattern they represent. This process terminates
with an expression containing only Triple template instances, hence
representing an RDF graph.
</p>



<div class="examplebox">
<h4 class="example-title">Simple template</h4>

<p>
The SubClassOf template is a simple representation of the
<code>rdfs:subClassOf</code> relationship.  It has two parameters <code>x1:SubClass</code>
and <code>x1:SuperClass</code>, the resources representing the parameter
variables may be given as a list. The code snippet below contains only
the head of the template.
</p>

<div class="org-src-container">
<pre class="src src-n3">t-owl-axiom:SubClassOf a ottr:Template ;
   ottr:withVariables ( x1:SubClass x1:SuperClass ) .
</pre>
</div>

<p>
The body of a template may in the RDF serialisation given as either
template instances or as regular RDF triples. Below, on the left, the
template is given with a body containing a single instance of a Triple
template. On the right, the equivalent representation using regular
RDF triples is used.
</p>

<div class="sidebyside">
<div class="sidebyside2">
<div class="org-src-container">
<pre class="src src-n3">
t-owl-axiom:SubClassOf a ottr:Template ;
   ottr:withVariables ( x1:SubClass x1:SuperClass ) .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/rdf/Triple&gt; ;
   ottr:withValues ( x1:SubClass rdfs:subClassOf x1:SuperClass ) .
</pre>
</div>

</div>
<div class="sidebyside2">
<div class="org-src-container">
<pre class="src src-n3">
t-owl-axiom:SubClassOf a ottr:Template ;
   ottr:withVariables ( x1:SubClass x1:SuperClass ) .

x1:SubClass rdfs:subClassOf x1:Superclass .
</pre>
</div>

</div>

</div>

</div>

<div class="examplebox">
<h4 class="example-title">Simple template instances</h4>

<p>
Instances of templates are given just as in templates bodies.
</p>

<div class="org-src-container">
<pre class="src src-n3">

[] ottr:templateRef t-owl-axiom:SubClassOf ;
   ottr:withValues ( ex:Pizza ex:Food ) .
[] ottr:templateRef t-owl-axiom:SubClassOf ;
   ottr:withValues ( ex:Burger ex:Food ) .
[] ottr:templateRef t-owl-axiom:SubClassOf ;
   ottr:withValues ( ex:FishSoup ex:Food ) .
</pre>
</div>

</div>
</div>
</div>


<div id="outline-container-orgf0a0429" class="outline-2">
<h2 id="orgf0a0429"><span class="section-number-2">3</span> Lutra</h2>
<div class="outline-text-2" id="text-3">
<p>
Lutra is our Java implementation of the OTTR template macro expander
is available as open source with an LGPL licence at
<a href="http://gitlab.com/ottr/lutra/lutra">http://gitlab.com/ottr/lutra/lutra</a>.  It can read and write templates
and instances on the formats represented above and expand them into
RDF graphs and OWL ontologies.
</p>

<div class="examplebox">
<h4 class="example-title">The Lutra CLI</h4>
<p>
This is the command line interface of Lutra.
</p>
<div class="org-src-container">
<pre class="src src-sh" id="orgc95bdb7">java -jar lutra.jar
</pre>
</div>

<pre class="example">
Unexpected exception: Missing required option: [-version Enable version mode., -expand Enable expand mode., -stottr Enable stottr mode., -tabottr Enable tabottr mode.]
usage: lutra -version|expand|stottr|tabottr [-in &lt;file|IRI&gt;] [-out &lt;file&gt;]
             [-lib &lt;path&gt; [-libExt &lt;ext,..&gt;]] [(flags)]
 -expand         Enable expand mode.
 -in &lt;arg&gt;       Path to optional input file or IRI. Defaults to stdin.
 -lib &lt;arg&gt;      Path to optional local template library root, read
                 recursively.
 -libExt &lt;arg&gt;   Comma-separated list of template file extensions to be
                 read from 'lib' (default: owl,rdf,ttl).
 -noCache        Disable caching.
 -noCheck        Disable various validation services, gives faster
                 processing.
 -noOWLOutput    Disable OWL API rendering of output.
 -out &lt;arg&gt;      Path to optional output file. Defaults to stout.
 -quiet          Disable logging.
 -stottr         Enable stottr mode.
 -tabottr        Enable tabottr mode.
 -version        Enable version mode.
</pre>

</div>

<div class="examplebox">
<h4 class="example-title">Converting to stOTTR serialisation</h4>

<p>
Lutra can convert templates and template instances serialised as RDF
into the stOTTR serialisation.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org1927a90">java -jar lutra.jar -stottr -in tpl/intro/SubClassOf1
</pre>
</div>

<pre class="example">
@prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix t-owl-axiom: &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix t-rdf: &lt;http://candidate.ottr.xyz/rdf/&gt; .
@prefix x1: &lt;http://candidate.ottr.xyz/owl/axiom/SubClassOf#&gt; .

t-owl-axiom:SubClassOf( t-owl-axiom:SubClassOf#SubClass : 1 , t-owl-axiom:SubClassOf#SuperClass : 1 )
  ::
  t-rdf:Triple( t-owl-axiom:SubClassOf#SubClass , rdfs:subClassOf , t-owl-axiom:SubClassOf#SuperClass ) .

</pre>

</div>

<div class="examplebox">
<h4 class="example-title">Expanding simple template instances</h4>

<p>
Lutra can expand template instances.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="orga0ec18b">java -jar lutra.jar -expand -in inst/intro/SubClassOf1Instances
</pre>
</div>

<pre class="example">
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix ex:      &lt;http://example.org#&gt; .

ex:Burger
      rdfs:subClassOf ex:Food .

ex:Pizza
      rdfs:subClassOf ex:Food .

ex:FishSoup
      rdfs:subClassOf ex:Food .

</pre>

</div>

<div class="examplebox">
<h4 class="example-title">Expanding Template definition</h4>

<p>
Note also that templates can be expanded, i.e., expanding the
instances in the body, hence resulting in a prototype of the pattern
the template represents.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org84c6087">java -jar lutra.jar -expand -in tpl/intro/SubClassOf1
</pre>
</div>

<pre class="example">
@prefix x1:      &lt;http://candidate.ottr.xyz/owl/axiom/SubClassOf#&gt; .
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix rdf:     &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .
@prefix t-owl-axiom:  &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix ottr:    &lt;http://ns.ottr.xyz/templates#&gt; .

x1:SubClass
      rdfs:subClassOf x1:SuperClass .

t-owl-axiom:SubClassOf
      a       ottr:Template ;
      ottr:withVariables (x1:SubClass x1:SuperClass) .

</pre>

</div>
</div>
</div>

<div id="outline-container-org4b89ef5" class="outline-2">
<h2 id="org4b89ef5"><span class="section-number-2">4</span> Parameter Types and Type checking</h2>
<div class="outline-text-2" id="text-4">
<p>
The type of the parameter specifies the permissible type of its
arguments. The available types are limited to a specified set of
classes and datatypes defined in the XSD, RDF, RDFS, and OWL
specifications, e.g,. <code>xsd:integer</code>, <code>rdf:Property</code>, <code>rdfs:Resource</code>
and <code>owl:ObjectProperty</code>.
</p>

<p>
The OWL ontology available at <a href="http://ns.ottr.xyz/templates-term-types.owl">http://ns.ottr.xyz/templates-term-types.owl</a>
declares all permissible types and organises them in a hierarchy of
<i>subtypes</i> and <i>incompatible</i> types, e.g.,
<code>owl:ObjectProperty</code> is a subtype of <code>rdf:Property</code> and <code>xsd:integer</code>
and <code>rdf:Property</code> are incompatible.  The most general and default
type is <code>rdfs:Resource</code>. 
</p>

<p>
This information is used to type check template instantiations; a
parameter may not be instantiated by an argument with an incompatible
type.
</p>

<div class="examplebox">
<h4 class="example-title">Declaring parameter types</h4>

<p>
Parameter types are specified by using dedicated properties. In order
to do so, the parameters of the templates must be explicitly
represented (here as blank nodes), and are uniquely order with an
index.
</p>

<div class="org-src-container">
<pre class="src src-n3">
t-owl-axiom:SubClassOfTest1 a ottr:Template ;
   ottr:hasParameter 
     [ ottr:index 1 ; ottr:classVariable x1:SubClass ] ,
     [ ottr:index 2 ; ottr:classVariable x1:SuperClass ] .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/rdf/Triple&gt; ;
   ottr:withValues ( x1:SubClass rdfs:subClassOf x1:SuperClass ) .
</pre>
</div>

<p>
This is the stOTTR representation of the template:
</p>

<pre class="example">
@prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix t-owl-axiom: &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix t-rdf: &lt;http://candidate.ottr.xyz/rdf/&gt; .
@prefix x1: &lt;http://candidate.ottr.xyz/owl/axiom/SubClassOf#&gt; .

t-owl-axiom:SubClassOfTest1( t-owl-axiom:SubClassOf#SubClass : 1 class , t-owl-axiom:SubClassOf#SuperClass : 1 class )
  ::
  t-rdf:Triple( t-owl-axiom:SubClassOf#SubClass , rdfs:subClassOf , t-owl-axiom:SubClassOf#SuperClass ) .

</pre>

<p>
Instances for templates with explicitly typed parameters are given as usual:
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] ottr:templateRef t-owl-axiom:SubClassOfTest1 ;
   ottr:withValues ( ex:Pizza ex:Food ) .
</pre>
</div>

<p>
Expanding the instance. To load the local template defined above, we
use the <code>-lib</code> option with the folder of the templates to be loaded as
argument. All templates, including subfolders (recursively), are
loaded.
</p>

<p>
A warning is given when loading the local template since its IRI is
different than it location.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="orgf151476">java -jar lutra.jar -expand -lib tpl/types -in inst/types/SubClassOf3Instances -out inst/types/SubClassOf3Instances.out
</pre>
</div>

<pre class="example">
0    [main] WARN  xyz.lutra.parser.TemplateLoader  - Template filename: 'tpl/types/SubClassOf3.ttl' is different from template name: 'http://candidate.ottr.xyz/owl/axiom/SubClassOfTest1"

</pre>

<p>
This is the result of the expansion:
</p>

<pre class="example">
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix ex:      &lt;http://example.org#&gt; .

ex:Pizza
      rdfs:subClassOf ex:Food .

</pre>

<p>
An instance of the template with arguments that are incompatible with
the type of the parameters will generate an error. In the following
template instance the first argument is a literal, which cannot
represent an OWL class.
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] ottr:templateRef t-owl-axiom:SubClassOfTest1 ;
   ottr:withValues ( "PizzaLiteral" ex:Food ) .
</pre>
</div>

<p>
Expanding this instance gives the following exception:
</p>

<blockquote>
<p>
Type error, expecting non literal for class variable, but found literal: PizzaLiteral
</p>
</blockquote>

<div class="org-src-container">
<pre class="src src-sh" id="org4a08d09">java -jar lutra.jar -expand -lib tpl/types -in inst/types/SubClassOf3Instances2
</pre>
</div>

<pre class="example">
0    [main] WARN  xyz.lutra.parser.TemplateLoader  - Template filename: 'tpl/types/SubClassOf3.ttl' is different from template name: 'http://candidate.ottr.xyz/owl/axiom/SubClassOfTest1"
4369 [main] ERROR xyz.lutra.parser.ParserUtils  - Type error, expecting non literal for class variable, but found literal: PizzaLiteral
Exception in thread "main" xyz.lutra.model.IllegalSubstitutionException: The substitution induced by template instance 5189294c:163da53fa2d:-7ff9 of template http://candidate.ottr.xyz/owl/axiom/SubClassOfTest1 is illegal. Error building substitution  with parameters [1: 5189294c:163da53fa2d:-7fff, 2: 5189294c:163da53fa2d:-7ffe] and arguments ["PizzaLiteral"^^xsd:string, ex:Food].  Error for parameter 1: 5189294c:163da53fa2d:-7fff and argument "PizzaLiteral"^^xsd:string. Type error, expecting non literal for class variable, but found literal: PizzaLiteral
	at xyz.lutra.model.TemplateInstance.buildSubstitutions(TemplateInstance.java:57)
	at xyz.lutra.model.TemplateInstance.&lt;init&gt;(TemplateInstance.java:32)
	at xyz.lutra.parser.TemplateInstanceParser.parseTemplateInstance(TemplateInstanceParser.java:123)
	at xyz.lutra.parser.TemplateInstanceParser.parseTemplateInstances(TemplateInstanceParser.java:59)
	at xyz.lutra.parser.TemplateInstanceParser.parse(TemplateInstanceParser.java:46)
	at xyz.lutra.parser.TemplateInstanceParser.getTemplateInstances(TemplateInstanceParser.java:41)
	at xyz.lutra.Expander.expand(Expander.java:96)
	at xyz.lutra.Expander.expand(Expander.java:61)
	at xyz.lutra.Expander.expand(Expander.java:50)
	at xyz.lutra.cli.CLI.main(CLI.java:112)
</pre>

</div>
</div>
</div>

<div id="outline-container-org15ac74f" class="outline-2">
<h2 id="org15ac74f"><span class="section-number-2">5</span> Cardinalities</h2>
<div class="outline-text-2" id="text-5">
<p>
The cardinality of a parameter specifies the number of required
arguments to the parameter.  There are four cardinalities: 
</p>
<ul class="org-ul">
<li><i>mandatory</i></li>
<li><i>optional</i></li>
<li><i>multiple</i></li>
<li><i>optional multiple</i>, which is shorthand for <i>mandatory</i> and
<i>optional</i> combined.</li>
</ul>

<p>
<i>Mandatory</i> is the default cardinality.  Mandatory parameters require
an argument, otherwise the instance is illegal.
</p>

<p>
Optional parameters permit a missing value; <code>ottr:none</code> designates
this value.  If <code>ottr:none</code> is an argument to a mandatory parameter of
an instance, the instance is ignored and will not be included in the
expansion.
</p>

<p>
A parameter with cardinality <i>multiple</i> requires a list as argument.
</p>

<p>
Parameters with cardinality <i>optional multiple</i> also
accept <i>ottr:none</i> as a value and behave like optional arguments.
</p>

<div class="examplebox">
<h4 class="example-title">Optional parameters</h4>

<p>
The following template is handy for expressing RDFS annotations on resources. All parameters, except the mandatory <code>resource</code> parameter are optional.
</p>

<div class="org-src-container">
<pre class="src src-n3">
&lt;http://candidate.ottr.xyz/rdfs/ResourceDescription&gt; a ottr:Template ;
    ottr:hasParameter
	[ ottr:index 1;  ottr:nonLiteralVariable  x2:resource ] ,
	[ ottr:index 2;  ottr:literalVariable     "label";      ottr:optional true ] ,
	[ ottr:index 3;  ottr:literalVariable     "comment";    ottr:optional true ] ,
	[ ottr:index 4;  ottr:variable            x2:seeOther;  ottr:optional true ] ,
	[ ottr:index 5;  ottr:variable            x2:defOther;  ottr:optional true ] .

x2:resource
    rdfs:label        "label" ;
    rdfs:comment      "comment" ;
    rdfs:seeAlso      x2:seeOther ;
    rdfs:isDefinedBy  x2:defOther .
</pre>
</div>

<p>
Example instances:
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] ottr:templateRef &lt;http://candidate.ottr.xyz/rdfs/ResourceDescription&gt; ;
   ottr:withValues ( ex:thing1 "label1" "comment1" ottr:none ottr:none ) .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/rdfs/ResourceDescription&gt; ;
   ottr:withValues ( ex:thing2 "label2" ottr:none ex:seeOther2 ex:defOther2  ) .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/rdfs/ResourceDescription&gt; ;
   ottr:withValues ( ex:thing3 ottr:none ottr:none ottr:none ottr:none ) .
</pre>
</div>

<p>
This is the result of expanding these instances. <code>ex:thing3</code> does not
occur in the output since all triples are removed.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org2dc34d4">java -jar lutra.jar -expand -in inst/card/ResourceDescriptionInstances
</pre>
</div>

<pre class="example">
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix ex:      &lt;http://example.org#&gt; .

ex:thing2
      rdfs:isDefinedBy ex:defOther2 ;
      rdfs:label "label2" ;
      rdfs:seeAlso ex:seeOther2 .

ex:thing1
      rdfs:comment "comment1" ;
      rdfs:label "label1" .

</pre>

</div>

<div class="examplebox">
<h4 class="example-title">Parameters with cardinality multiple</h4>

<p>
The <i>multiple</i> cardinality is useful for expression that naturally
should accept multiple values.  The <code>EquivObjectUnionOf</code> template expresses that a class
is equivalent to a union of classes as according to the OWL specification.
</p>

<p>
The template directly depends on, i.e,. its body contains instances
of, other templates which are available at their IRI address. Lutra
fetches these template definitions on expansion.
</p>

<div class="org-src-container">
<pre class="src src-n3">
t-owl-axiom:EquivObjectUnionOf a ottr:Template ;
    ottr:hasParameter :pRestriction, :pList .

:pRestriction   ottr:index 1;  ottr:classVariable  :xRestriction .
:pList          ottr:index 2;  ottr:listVariable    ( :item1 :item2 ) .

[] ottr:templateRef t-owl-axiom:EquivalentClass ;
   ottr:withValues ( :xRestriction _:restriction ) .

[] ottr:templateRef t-owl-rstr:ObjectUnionOf ;
    ottr:withValues ( _:restriction ( :item1 :item2 ) ) .
</pre>
</div>

<p>
An example instance:
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] ottr:templateRef t-owl-axiom:EquivObjectUnionOf ;
   ottr:withValues ( ex:MyFood ( ex:Pizza ex:Burger ex:FishSoup) ) .
</pre>
</div>

<p>
This expands to:
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org28a30ae">java -jar lutra.jar -expand -in inst/card/EquivObjectUnionOfInstances
</pre>
</div>

<pre class="example">
@prefix ex:      &lt;http://example.org#&gt; .
@prefix owl:     &lt;http://www.w3.org/2002/07/owl#&gt; .
@prefix rdf:     &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .

ex:MyFood
      a       owl:Class ;
      owl:equivalentClass
              [ a       owl:Class ;
                owl:unionOf (ex:Pizza ex:Burger ex:FishSoup)
              ] .

</pre>

</div>
</div>
</div>

<div id="outline-container-org42594ee" class="outline-2">
<h2 id="org42594ee"><span class="section-number-2">6</span> Expansion Modes</h2>
<div class="outline-text-2" id="text-6">
<p>
Instances of templates that accept list arguments may be used together
with an expansion <i>mode</i>.  The mode indicates that the list arguments
will in the expansion be used to generate multiple instances of the
template.
</p>

<p>
The instances to be generated are calculated by temporarily
considering all arguments to the instance as lists, where single value
arguments become singular lists.  Currently only one mode, cross mode,
is implemented, but others are possible.  In cross mode, one instance
per element in the cross product of the temporary lists is generated
</p>

<p>
List arguments used without an expansion mode behave just like regular
arguments.  
</p>

<div class="examplebox">
<h4 class="example-title">Expansion mode</h4>

<p>
To illustrate the effect of using expansion mode, we introduce three
different variants of the <code>SubClassOf</code> template and show the results
of an example instance.
</p>


<p>
<code>SubClassOfTest1</code> accepts a list of superclasses:
</p>

<div class="org-src-container">
<pre class="src src-n3">
t-owl-axiom:SubClassOfTest1 a ottr:Template ;
   ottr:hasParameter 
     [ ottr:index 1 ; ottr:classVariable x1:SubClass ] ,
     [ ottr:index 2 ; ottr:listVariable ( x1:SuperClasses ) ] .

[] ottr:templateRef t-owl-axiom:SubClassOf ;
   ottr:hasArgument
	[ ottr:index 1; ottr:value x1:SubClass ] ,
	[ ottr:index 2; ottr:eachValue ( x1:SuperClasses ) ] .
</pre>
</div>

<p>
Example instance:
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] ottr:templateRef t-owl-axiom:SubClassOfTest1 ;
   ottr:withValues ( ex:MyFood ( ex:Pizza ex:Burger ex:FishSoup) ) .
</pre>
</div>

<p>
Expansion:
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org68acacf">java -jar lutra.jar -quiet -expand -lib tpl/mode -in tpl/mode/SubClassOf1Instances
</pre>
</div>

<pre class="example">
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix ex:      &lt;http://example.org#&gt; .

ex:MyFood
      rdfs:subClassOf ex:Burger , ex:Pizza , ex:FishSoup .


</pre>

<p>
<code>SubClassOfTest2</code> accepts a list of subclasses:
</p>

<div class="org-src-container">
<pre class="src src-n3">
t-owl-axiom:SubClassOfTest2 a ottr:Template ;
   ottr:hasParameter 
     [ ottr:index 1 ; ottr:listVariable ( x1:SubClasses ) ] ,
     [ ottr:index 2 ; ottr:classVariable x1:SuperClass ] .

[] ottr:templateRef t-owl-axiom:SubClassOf ;
   ottr:hasArgument
	[ ottr:index 1; ottr:eachValue ( x1:SubClasses ) ] ,
	[ ottr:index 2; ottr:value x1:SuperClass ] .
</pre>
</div>

<p>
Example instance:
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] ottr:templateRef t-owl-axiom:SubClassOfTest2 ;
   ottr:withValues ( ( ex:Tropical ex:Pepperoni ex:Grandiosa ) ex:Pizza ) .
</pre>
</div>

<p>
Expansion:
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org799bfa2">java -jar lutra.jar -quiet -expand -lib tpl/mode -in tpl/mode/SubClassOf2Instances
</pre>
</div>

<pre class="example">
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix ex:      &lt;http://example.org#&gt; .

ex:Grandiosa
      rdfs:subClassOf ex:Pizza .

ex:Pepperoni
      rdfs:subClassOf ex:Pizza .

ex:Tropical
      rdfs:subClassOf ex:Pizza .

</pre>


<p>
<code>SubClassOfTest3</code> accepts a list of subclasses and a a list of superclasses
</p>

<div class="org-src-container">
<pre class="src src-n3">
t-owl-axiom:SubClassOfTest3 a ottr:Template ;
   ottr:hasParameter 
     [ ottr:index 1 ; ottr:listVariable ( x1:SubClasses ) ] ,
     [ ottr:index 2 ; ottr:listVariable ( x1:SuperClasses ) ] .

[] ottr:templateRef t-owl-axiom:SubClassOf ;
   ottr:hasArgument
	[ ottr:index 1; ottr:eachValue ( x1:SubClasses ) ] ,
	[ ottr:index 2; ottr:eachValue ( x1:SuperClasses ) ] .
</pre>
</div>

<p>
Example instance:
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] ottr:templateRef t-owl-axiom:SubClassOfTest3 ;
   ottr:withValues ( ( ex:A1 ex:A2 ex:A3) ( ex:B1 ex:B2 ex:B3 ) ) .
</pre>
</div>

<p>
Expansion:
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org169122e">java -jar lutra.jar -quiet -expand -lib tpl/mode -in tpl/mode/SubClassOf3Instances
</pre>
</div>

<pre class="example">
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix ex:      &lt;http://example.org#&gt; .

ex:A3
      rdfs:subClassOf ex:B3 , ex:B2 , ex:B1 .

ex:A2
      rdfs:subClassOf ex:B3 , ex:B2 , ex:B1 .

ex:A1
      rdfs:subClassOf ex:B3 , ex:B2 , ex:B1 .

</pre>

</div>
</div>
</div>

<div id="outline-container-org6900f15" class="outline-2">
<h2 id="org6900f15"><span class="section-number-2">7</span> Combining features: NamedPizza</h2>
<div class="outline-text-2" id="text-7">
<p>
This section illustrates the example used in the demo paper, the
<code>NamedPizza</code> template
</p>

<p>
It is available at its IRI:
<a href="http://draft.ottr.xyz/pizza/NamedPizza">http://draft.ottr.xyz/pizza/NamedPizza</a>. This page displays the
template in different serialisations, lists its dependencies,
visualises its prototypical pattern, and provides links to other
available formats that can be generated from an OTTR template.
</p>

<div class="examplebox">
<h4 class="example-title">NamedPizza</h4>

<p>
This is the wOTTR serialisation of the <code>NamedPizza</code> template. 
</p>

<div class="org-src-container">
<pre class="src src-n3">
&lt;http://draft.ottr.xyz/pizza/NamedPizza&gt; a ottr:Template ;
  ottr:hasParameter
     [ ottr:index 1 ; ottr:classVariable :pizza ] ,
     [ ottr:index 2 ; ottr:individualVariable :country; ottr:optional true ] ,
     [ ottr:index 3 ; ottr:listVariable (:toppings) ]  .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/owl/axiom/SubClassOf&gt; ;
   ottr:withValues ( :pizza p:NamedPizza ) .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/owl/axiom/SubObjectSomeValuesFrom&gt; ;
   ottr:hasArgument
	[ ottr:index 1; ottr:value :pizza ] ,
	[ ottr:index 2; ottr:value p:hasTopping ] ,
	[ ottr:index 3; ottr:eachValue (:toppings) ] .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/owl/axiom/SubObjectHasValue&gt; ;
   ottr:withValues ( :pizza p:hasCountryOfOrigin :country ) .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/owl/axiom/SubObjectAllValuesFrom&gt; ;
   ottr:withValues ( :pizza p:hasTopping _:alltoppings ) .

[] ottr:templateRef &lt;http://candidate.ottr.xyz/owl/restriction/ObjectUnionOf&gt; ;
   ottr:withValues ( _:alltoppings (:toppings) ) .
</pre>
</div>

<p>
Its stOTTR serialisation; note that we are reading the template
definition from its IRI, where the template is published.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="orgcd144c4">java -jar lutra.jar -stottr -in http://draft.ottr.xyz/pizza/NamedPizza
</pre>
</div>

<pre class="example">
@prefix : &lt;http://draft.ottr.xyz/pizza/NamedPizza#&gt; .
@prefix p: &lt;http://www.co-ode.org/ontologies/pizza/pizza.owl#&gt; .
@prefix t-owl-axiom: &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix t-owl-rstr: &lt;http://candidate.ottr.xyz/owl/restriction/&gt; .

http://draft.ottr.xyz/pizza/NamedPizza( :pizza : 1 class , :country : ? individual , &lt;:toppings&gt; : + list )
  ::
  t-owl-axiom:SubClassOf( :pizza , p:NamedPizza )
  t-owl-axiom:SubObjectAllValuesFrom( :pizza , p:hasTopping , _:b1 )
  t-owl-axiom:SubObjectHasValue( :pizza , p:hasCountryOfOrigin , :country )
  X  | t-owl-axiom:SubObjectSomeValuesFrom( :pizza , p:hasTopping , &lt;:toppings&gt; )
  t-owl-rstr:ObjectUnionOf( _:b1 , &lt;:toppings&gt; ) .
</pre>

<p>
Example instance containing three pizzas. Note that the file
specifies that it is an OWL ontology.
</p>

<div class="org-src-container">
<pre class="src src-n3">
[] a owl:Ontology .

[] ottr:templateRef &lt;http://draft.ottr.xyz/pizza/NamedPizza&gt; ;
   ottr:withValues ( ex:Grandiosa ottr:none ( ex:Tomato ex:Jarlsberg ex:Ham ex:SweetPepper ) ) .
[] ottr:templateRef &lt;http://draft.ottr.xyz/pizza/NamedPizza&gt; ;
   ottr:withValues ( ex:Margherita ex:Italy ( ex:Tomato ex:Mozzarella ) ) .
[] ottr:templateRef &lt;http://draft.ottr.xyz/pizza/NamedPizza&gt; ;
   ottr:withValues ( ex:Tropical ex:Hawaii ( ex:Tomato ex:Cheese ex:Pineapple ex:Ham ) ) .
</pre>
</div>

<p>
The result of the expansion.  The occurrence of the <code>[] a
owl:Ontology</code> triple in the input, causes Lutra to render the output
using the OWLAPI; this can be disabled with the <code>-noOWLOutput</code> flag.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org4a8556a">java -jar lutra.jar -expand -in tpl/pizza/NamedPizzaInstances
</pre>
</div>

<pre class="example">
@prefix p: &lt;http://www.co-ode.org/ontologies/pizza/pizza.owl#&gt; .
@prefix ex: &lt;http://example.org#&gt; .
@prefix owl: &lt;http://www.w3.org/2002/07/owl#&gt; .
@prefix rdf: &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .
@prefix xml: &lt;http://www.w3.org/XML/1998/namespace&gt; .
@prefix xsd: &lt;http://www.w3.org/2001/XMLSchema#&gt; .
@prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@base &lt;http://www.w3.org/2002/07/owl#&gt; .

[ rdf:type owl:Ontology
 ] .

#################################################################
#    Object Properties
#################################################################

###  http://www.co-ode.org/ontologies/pizza/pizza.owl#hasCountryOfOrigin
p:hasCountryOfOrigin rdf:type owl:ObjectProperty .


###  http://www.co-ode.org/ontologies/pizza/pizza.owl#hasTopping
p:hasTopping rdf:type owl:ObjectProperty .


#################################################################
#    Classes
#################################################################

###  http://example.org#Cheese
ex:Cheese rdf:type owl:Class .


###  http://example.org#Grandiosa
ex:Grandiosa rdf:type owl:Class ;
             rdfs:subClassOf p:NamedPizza ,
                             [ rdf:type owl:Restriction ;
                               owl:onProperty p:hasTopping ;
                               owl:someValuesFrom ex:Ham
                             ] ,
                             [ rdf:type owl:Restriction ;
                               owl:onProperty p:hasTopping ;
                               owl:someValuesFrom ex:Jarlsberg
                             ] ,
                             [ rdf:type owl:Restriction ;
                               owl:onProperty p:hasTopping ;
                               owl:someValuesFrom ex:SweetPepper
                             ] ,
                             [ rdf:type owl:Restriction ;
                               owl:onProperty p:hasTopping ;
                               owl:someValuesFrom ex:Tomato
                             ] ,
                             [ rdf:type owl:Restriction ;
                               owl:onProperty p:hasTopping ;
                               owl:allValuesFrom [ rdf:type owl:Class ;
                                                   owl:unionOf ( ex:Ham
                                                                 ex:Jarlsberg
                                                                 ex:SweetPepper
                                                                 ex:Tomato
                                                               )
                                                 ]
                             ] .


###  http://example.org#Ham
ex:Ham rdf:type owl:Class .


###  http://example.org#Jarlsberg
ex:Jarlsberg rdf:type owl:Class .


###  http://example.org#Margherita
ex:Margherita rdf:type owl:Class ;
              rdfs:subClassOf p:NamedPizza ,
                              [ rdf:type owl:Restriction ;
                                owl:onProperty p:hasTopping ;
                                owl:someValuesFrom ex:Mozzarella
                              ] ,
                              [ rdf:type owl:Restriction ;
                                owl:onProperty p:hasTopping ;
                                owl:someValuesFrom ex:Tomato
                              ] ,
                              [ rdf:type owl:Restriction ;
                                owl:onProperty p:hasTopping ;
                                owl:allValuesFrom [ rdf:type owl:Class ;
                                                    owl:unionOf ( ex:Mozzarella
                                                                  ex:Tomato
                                                                )
                                                  ]
                              ] ,
                              [ rdf:type owl:Restriction ;
                                owl:onProperty p:hasCountryOfOrigin ;
                                owl:hasValue ex:Italy
                              ] .


###  http://example.org#Mozzarella
ex:Mozzarella rdf:type owl:Class .


###  http://example.org#Pineapple
ex:Pineapple rdf:type owl:Class .


###  http://example.org#SweetPepper
ex:SweetPepper rdf:type owl:Class .


###  http://example.org#Tomato
ex:Tomato rdf:type owl:Class .


###  http://example.org#Tropical
ex:Tropical rdf:type owl:Class ;
            rdfs:subClassOf p:NamedPizza ,
                            [ rdf:type owl:Restriction ;
                              owl:onProperty p:hasTopping ;
                              owl:someValuesFrom ex:Cheese
                            ] ,
                            [ rdf:type owl:Restriction ;
                              owl:onProperty p:hasTopping ;
                              owl:someValuesFrom ex:Ham
                            ] ,
                            [ rdf:type owl:Restriction ;
                              owl:onProperty p:hasTopping ;
                              owl:someValuesFrom ex:Pineapple
                            ] ,
                            [ rdf:type owl:Restriction ;
                              owl:onProperty p:hasTopping ;
                              owl:someValuesFrom ex:Tomato
                            ] ,
                            [ rdf:type owl:Restriction ;
                              owl:onProperty p:hasTopping ;
                              owl:allValuesFrom [ rdf:type owl:Class ;
                                                  owl:unionOf ( ex:Cheese
                                                                ex:Ham
                                                                ex:Pineapple
                                                                ex:Tomato
                                                              )
                                                ]
                            ] ,
                            [ rdf:type owl:Restriction ;
                              owl:onProperty p:hasCountryOfOrigin ;
                              owl:hasValue ex:Hawaii
                            ] .


###  http://www.co-ode.org/ontologies/pizza/pizza.owl#NamedPizza
p:NamedPizza rdf:type owl:Class .


#################################################################
#    Individuals
#################################################################

###  http://example.org#Hawaii
ex:Hawaii rdf:type owl:NamedIndividual .


###  http://example.org#Italy
ex:Italy rdf:type owl:NamedIndividual .


###  Generated by the OWL API (version 0.1.6) https://github.com/owlcs/owlapi/

</pre>

</div>
</div>

<div id="outline-container-orgf3d3b51" class="outline-3">
<h3 id="orgf3d3b51"><span class="section-number-3">7.1</span> tabOTTR</h3>
<div class="outline-text-3" id="text-7-1">
<p>
The tabOTTR format is useful for compactly giving multiple
instances of templates, and makes OTTR available to users who
prefer working with tabular formats such as spreadsheets.
</p>

<div class="examplebox">
<h4 class="example-title">NamedPizza tabular input</h4>

<p>
The code block below is copy of one of the sheets in the Excel
spreadsheet at <code>tab/NamedPizza-instances.xlsx</code> (available in the git
repo: <a href="https://gitlab.com/ottr/pub/iswc2018-demo">https://gitlab.com/ottr/pub/iswc2018-demo</a>).
</p>

<div class="org-src-container">
<pre class="src src-n3">#OTTR	prefix	
owl	http://www.w3.org/2002/07/owl#	
rdf	http://www.w3.org/1999/02/22-rdf-syntax-ns#	
xsd	http://www.w3.org/2001/XMLSchema#	
rdfs	http://www.w3.org/2000/01/rdf-schema#	
ottr	http://ns.ottr.xyz/templates#	
	http://example.com#	
#OTTR	end	

#OTTR	template	http://draft.ottr.xyz/pizza/NamedPizza
Pizza	Country	Toppings
1	2	3
iri	iri	iri+
:Margherita	:Italy	:Tomato|:Mozzarella
:Grandiosa	:Norway	:Tomato|:Jarlsberg|:Ham|:SweetPepper
:Hawaii		:Tomato|:Cheese|:Ham|:PineApple
:BigOne		:Tomato|:Cheese|:Ham
#OTTR	end
</pre>
</div>

<p>
Lutra can expand the instances represented in tabOTTR format in the Excel file:
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org8cc67f9">java -jar lutra.jar -tabottr -in tab/NamedPizza-instances.xlsx
</pre>
</div>

<pre class="example">
@prefix :        &lt;http://example.com#&gt; .
@prefix p:       &lt;http://www.co-ode.org/ontologies/pizza/pizza.owl#&gt; .
@prefix rdfs:    &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix owl:     &lt;http://www.w3.org/2002/07/owl#&gt; .
@prefix rdf:     &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .

:Cheese
      a       owl:Class .

:Pear
      a       owl:Class .

:PineApple
      a       owl:Class .

:Margherita
      rdfs:subClassOf p:NamedPizza ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Tomato
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:allValuesFrom
                        [ a       owl:Class ;
                          owl:unionOf (:Tomato :Mozzarella)
                        ] ;
                owl:onProperty p:hasTopping
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:hasValue :Italy ;
                owl:onProperty p:hasCountryOfOrigin
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Mozzarella
              ] .

p:hasTopping
      a       owl:ObjectProperty .

:Hawaii
      rdfs:subClassOf p:NamedPizza ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Tomato
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Cheese
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :PineApple
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Ham
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:allValuesFrom
                        [ a       owl:Class ;
                          owl:unionOf (:Tomato :Cheese :Ham :PineApple)
                        ] ;
                owl:onProperty p:hasTopping
              ] .

:Grandiosa
      rdfs:subClassOf p:NamedPizza ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Tomato
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:allValuesFrom
                        [ a       owl:Class ;
                          owl:unionOf (:Tomato :Jarlsberg :Ham :SweetPepper)
                        ] ;
                owl:onProperty p:hasTopping
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Ham
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Jarlsberg
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :SweetPepper
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:hasValue :Norway ;
                owl:onProperty p:hasCountryOfOrigin
              ] .

:Apple
      a       owl:Class .

:Jarlsberg
      a       owl:Class .

:TuttiFrutti
      rdfs:subClassOf p:NamedPizza ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Tomato
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:allValuesFrom
                        [ a       owl:Class ;
                          owl:unionOf (:Tomato :Apple :Pear)
                        ] ;
                owl:onProperty p:hasTopping
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Apple
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Pear
              ] .

:BigOne
      rdfs:subClassOf p:NamedPizza ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Cheese
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Ham
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:onProperty p:hasTopping ;
                owl:someValuesFrom :Tomato
              ] ;
      rdfs:subClassOf
              [ a       owl:Restriction ;
                owl:allValuesFrom
                        [ a       owl:Class ;
                          owl:unionOf (:Tomato :Cheese :Ham)
                        ] ;
                owl:onProperty p:hasTopping
              ] .

p:hasCountryOfOrigin
      a       owl:ObjectProperty .

:Tomato
      a       owl:Class .

:SweetPepper
      a       owl:Class .

:Ham  a       owl:Class .

:Mozzarella
      a       owl:Class .

</pre>

</div>
</div>
</div>



<div id="outline-container-org9627685" class="outline-3">
<h3 id="org9627685"><span class="section-number-3">7.2</span> Generated formats from OTTR templates</h3>
<div class="outline-text-3" id="text-7-2">
<div class="examplebox">
<h4 class="example-title">Other formats from templates</h4>

<p>
This example illustrates some of the formats that may be generated
from the <code>NamedPizza</code> template.
</p>

<p>
<b>SPARQL SELECT</b> query of pattern
</p>

<pre class="example">
SELECT  *
WHERE
  { _:b0      owl:allValuesFrom   _:b3 ;
	      owl:onProperty      p:hasTopping ;
	      rdf:type            owl:Restriction .
    _:b1      owl:hasValue        ?param2 ;
	      owl:onProperty      p:hasCountryOfOrigin ;
	      rdf:type            owl:Restriction .
    _:b2      owl:onProperty      p:hasTopping ;
	      owl:someValuesFrom  ?param3item ;
	      rdf:type            owl:Restriction .
    _:b3      owl:unionOf         ?param3 ;
	      rdf:type            owl:Class .
    ?param1   rdfs:subClassOf     _:b0 ;
	      rdfs:subClassOf     _:b1 ;
	      rdfs:subClassOf     _:b2 ;
	      rdfs:subClassOf     p:NamedPizza .
    ?param3item  rdf:type         owl:Class .
    p:hasCountryOfOrigin
	      rdf:type            owl:ObjectProperty .
    p:hasTopping  rdf:type        owl:ObjectProperty .
    ?param3  (rdf:rest)*/rdf:first ?param3item
  }
</pre>

<p>
Also available at
<a href="http://osl.ottr.xyz/lifting/select/?tpl=http://draft.ottr.xyz/pizza/NamedPizza">http://osl.ottr.xyz/lifting/select/?tpl=http://draft.ottr.xyz/pizza/NamedPizza</a>
</p>

<p>
<b>XSD+SAWSDL</b> description of template head:
</p>

<p>
Available at <a href="http://osl.ottr.xyz/format/head/xml/?tpl=http://draft.ottr.xyz/pizza/NamedPizza">http://osl.ottr.xyz/format/head/xml/?tpl=http://draft.ottr.xyz/pizza/NamedPizza</a>
</p>

<p>
<b>XML</b> sample of template head:
</p>

<p>
Available at <a href="http://osl.ottr.xyz/sample/head/xml/?tpl=http://draft.ottr.xyz/pizza/NamedPizza">http://osl.ottr.xyz/sample/head/xml/?tpl=http://draft.ottr.xyz/pizza/NamedPizza</a>
</p>

</div>
</div>
</div>
</div>

<div id="outline-container-orgf77b687" class="outline-2">
<h2 id="orgf77b687"><span class="section-number-2">8</span> Finding Redundancies</h2>
<div class="outline-text-2" id="text-8">
<p>
We here present redundancies in template libraries
and our method of finding and fixing them.
We here work with two types of redundancy: a lack of reuse of existing
templates and recurring patterns not captured by templates
within the library. If the body of a template <code>T</code> is a subset
of another template <code>R</code>'s body, assuming an appropriate substitution of the
variables of <code>T</code>, then <code>R</code> has a lack of reuse of <code>T</code>.
On the other hand, a pattern of template instances might occur
across multiple templates without there being any template having this
pattern as a body. This type of redundancy is called an uncaptured pattern.
A lack of reuse can be fixed by simply substituting the offending instances
in <code>R</code> by an appropriate instance of <code>T</code>. To fix a redundancy
resulting from an uncaptured pattern, we first have to introduce a new template
that has the recurring pattern as its body and then refactor out the redundancy.
</p>

<p>
A naive method for finding the two types of redundancy based on direct unification
of subsets of the template's bodies is infeasible for large template libraries.
We have therefore developed an efficient method for finding lack of reuse and uncaptured patterns,
which over-approximates the results of unification
based on the notion of a dependency pair, which intuitively captures repeated
use of templates without considering parameters.
A dependency pair is a pair of a multiset of templates <code>I</code> and a set of templates <code>T</code>,
such that all templates in <code>T</code> have at least as many occurences of each
template in <code>I</code> as they occur in <code>I</code> in its body.
The idea is that <code>I</code> then describes a pattern that is used in the templates <code>T</code>.
In order to also detect patterns containing different <code>Triple</code> instances, we
treat a <code>Triple</code> instance <code>(s, p, o)</code> as an instance of the form <code>p(s,o)</code> and thus <code>p</code> as a template.
</p>

<p>
For each template <code>t</code> in <code>T</code> in each dependency pair <code>(I, T)</code> we can construct a suggestion of a new template <code>s</code>
by extracting the instances in <code>t</code>'s body corresponding to the instances in <code>I</code>,
making all parameters
and constants (except blank nodes only occuring in the pattern) in this set of instances a parameter. 
For each such template <code>s</code> we have one of three cases: 
(1) the body of this template does not represent a repeated pattern in the other templates of <code>T</code>;
(2) <code>s</code> is equal to an already existing template, in which case we have found
an instance of lack of reuse in all the other template of <code>T</code> which
shares the pattern;
(3) we have found an uncaptured pattern represented which is remedied by the introduction of <code>s</code>.
</p>

<p>
The following examples demonstrates the method for finding
redundancies in a template library. The template library used in the
example is found in the folder <code>redundancy-templates/</code>.
</p>

<p>
The analysis program is not available as open source and is therefore
packaged in a separate jar file.
</p>

<div class="examplebox">
<h4 class="example-title">Analysis of example patterns</h4>

<p>
In the following example, only the patterns from the above mentioned paper is presented.
</p>

<p>
The program first outputs the template definitions loaded into the
library.  Then it prints each dependency pair found from the loaded templates; here is an example:
</p>

<pre class="example">
Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-axiom:SubObjectAllValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza
</pre>

<p>
This dependency pair shows that both the templates <code>pz:NamedPizza</code> and <code>ex:Burger</code> contain
one instance (denoted by the trailing integer <code>:1</code>) of each of the
templates <code>t-owl-axiom:SubClassOf</code>, <code>t-owl-axiom:SubObjectSomeValuesFrom</code>,
<code>t-owl-axiom:SubObjectAllValuesFrom</code> and <code>t-owl-rstr:ObjectUnionOf</code>.
</p>

<p>
The dependency pair is followed by the
template suggestions constructed from that dependency pair. Here it
removes duplicate suggestions via unification of templates. The suggested template from this dependency pair is:
</p>

<pre class="example">
[name68_0](:subject, :hasCondiment, &lt;:condiments&gt;, ex:Burger) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    t-owl-rstr:ObjectUnionOf(25134aae:163da50f911:-7f93, &lt;:condiments&gt;)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, 25134aae:163da50f911:-7f93)
</pre>

<p>
Finally,
if there are any lack of reuse captured by this dependency pair, these
are reported:
</p>

<pre class="example">
http://example.org/Burger has a lack of reuse of http://draft.ottr.xyz/pizza/NamedPizza
</pre>

<p>
Below is the complete output from analysing the templates:
</p>

<div class="org-src-container">
<pre class="src src-sh" id="orgc021af1">java -jar findPatterns.jar -p redundancy-templates/
</pre>
</div>

<pre class="example">
======================================
==========~Templates~=================
======================================

@prefix :  &lt;http://candidate.ottr.xyz/owl/axiom/SubClassOf#&gt; .
@prefix t-rdf:  &lt;http://candidate.ottr.xyz/rdf/&gt; .
@prefix owl:  &lt;http://www.w3.org/2002/07/owl#&gt; .
@prefix xsd:  &lt;http://www.w3.org/2001/XMLSchema#&gt; .
@prefix skos:  &lt;http://www.w3.org/2004/02/skos/core#&gt; .
@prefix rdfs:  &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix t-owl-rstr:  &lt;http://candidate.ottr.xyz/owl/restriction/&gt; .
@prefix t-owl-ax:  &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix p:  &lt;http://www.co-ode.org/ontologies/pizza/pizza.owl#&gt; .
@prefix ex:  &lt;http://example.org/#&gt; .
@prefix rdf:  &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .
@prefix t-owl-axiom:  &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix ottr:  &lt;http://ns.ottr.xyz/templates#&gt; .
@prefix t-owl-atom:  &lt;http://candidate.ottr.xyz/owl/atom/&gt; .

t-owl-axiom:SubObjectAllValuesFrom(:xClass, :xProperty, :xRange) ::
    t-owl-rstr:ObjectAllValuesFrom(-17351486:163da54f4a0:-7f7b, :xProperty, :xRange)
    t-owl-axiom:SubClassOf(:xClass, -17351486:163da54f4a0:-7f7b)


t-owl-rstr:ObjectUnionOf(:xRestriction, &lt;:item1,:item2&gt;) ::
    t-owl-atom:TypedListRelation(:xRestriction, owl:Class, owl:unionOf, &lt;:item1,:item2&gt;)


http://example.org/BurgerMeal(:subject, &lt;:sides&gt;) ::
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasSide, -17351486:163da54f4a0:-7fa8)
    t-owl-rstr:ObjectUnionOf(-17351486:163da54f4a0:-7fa8, &lt;:sides&gt;)
    t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasMain, ex:Burger)


http://example.org/Burger(:subject, &lt;:condiments&gt;, &lt;label&gt;, prefLabel : ?, definition : ?) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-rdf:Triple(:subject, skos:definition, definition)
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-owl-rstr:ObjectUnionOf(-17351486:163da54f4a0:-7f93, &lt;:condiments&gt;)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, -17351486:163da54f4a0:-7f93)


t-owl-axiom:SubObjectSomeValuesFrom(:xClass, :xProperty, :xRange) ::
    t-owl-rstr:ObjectSomeValuesFrom(-17351486:163da54f4a0:-7fef, :xProperty, :xRange)
    t-owl-axiom:SubClassOf(:xClass, -17351486:163da54f4a0:-7fef)


t-owl-axiom:SubClassOf(:xSubClass, :xSuperClass) ::
    t-rdf:Triple(:xSubClass, rdf:type, owl:Class)
    t-rdf:Triple(:xSuperClass, rdf:type, owl:Class)
    t-rdf:Triple(:xSubClass, rdfs:subClassOf, :xSuperClass)


http://draft.ottr.xyz/pizza/NamedPizza(:pizza, &lt;:toppings&gt;) ::
    t-owl-axiom:SubClassOf(:pizza, p:NamedPizza)
    t-owl-axiom:SubObjectAllValuesFrom(:pizza, p:hasTopping, -17351486:163da54f4a0:-7fd6)
    t-owl-rstr:ObjectUnionOf(-17351486:163da54f4a0:-7fd6, &lt;:toppings&gt;)
    x | t-owl-axiom:SubObjectSomeValuesFrom(:pizza, p:hasTopping, &lt;:toppings&gt;)


http://draft.ottr.xyz/pizza/Annotation(:subject, &lt;label&gt;, prefLabel, definition) ::
    t-rdf:Triple(:subject, skos:definition, definition)
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)


http://draft.ottr.xyz/pizza/AnnotatedPizza(:subject, &lt;label&gt;, prefLabel : ?, definition : ?) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-rdf:Triple(:subject, skos:definition, definition)
    t-owl-axiom:SubClassOf(:subject, p:Pizza)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)

Checking for redundancy...  Done
Following redundancies found:

======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-axiom:SubObjectAllValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name68_0](:subject, :hasCondiment, &lt;:condiments&gt;, ex:Burger) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-owl-rstr:ObjectUnionOf(-17351486:163da54f4a0:-7f93, &lt;:condiments&gt;)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, -17351486:163da54f4a0:-7f93)

===~Lack of reuse~===

http://example.org/Burger has a lack of reuse of http://draft.ottr.xyz/pizza/NamedPizza

======================================
==========~Dependency Pair~===========
======================================

Pattern
	skos:definition:1
	rdfs:label:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/Annotation
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name63_1](&lt;label&gt;, :subject, prefLabel, definition) ::
    t-rdf:Triple(:subject, skos:definition, definition)
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)

===~Lack of reuse~===

http://example.org/Burger has a lack of reuse of http://draft.ottr.xyz/pizza/Annotation
http://draft.ottr.xyz/pizza/AnnotatedPizza has a lack of reuse of http://draft.ottr.xyz/pizza/Annotation
</pre>

</div>

<div class="examplebox">
<h4 class="example-title">Analysis of all patterns</h4>

<p>
In this example we present all redundancies in the entire library.
</p>

<div class="org-src-container">
<pre class="src src-sh" id="org049fffc">java -jar findPatterns.jar -a redundancy-templates/
</pre>
</div>

<pre class="example">
======================================
==========~Templates~=================
======================================

@prefix :  &lt;http://candidate.ottr.xyz/owl/axiom/SubClassOf#&gt; .
@prefix t-rdf:  &lt;http://candidate.ottr.xyz/rdf/&gt; .
@prefix owl:  &lt;http://www.w3.org/2002/07/owl#&gt; .
@prefix xsd:  &lt;http://www.w3.org/2001/XMLSchema#&gt; .
@prefix skos:  &lt;http://www.w3.org/2004/02/skos/core#&gt; .
@prefix rdfs:  &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix t-owl-rstr:  &lt;http://candidate.ottr.xyz/owl/restriction/&gt; .
@prefix t-owl-ax:  &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix p:  &lt;http://www.co-ode.org/ontologies/pizza/pizza.owl#&gt; .
@prefix ex:  &lt;http://example.org/#&gt; .
@prefix rdf:  &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .
@prefix t-owl-axiom:  &lt;http://candidate.ottr.xyz/owl/axiom/&gt; .
@prefix ottr:  &lt;http://ns.ottr.xyz/templates#&gt; .
@prefix t-owl-atom:  &lt;http://candidate.ottr.xyz/owl/atom/&gt; .

t-owl-axiom:SubObjectAllValuesFrom(:xClass, :xProperty, :xRange) ::
    t-owl-rstr:ObjectAllValuesFrom(-48c2c56f:163da54fa86:-7f7b, :xProperty, :xRange)
    t-owl-axiom:SubClassOf(:xClass, -48c2c56f:163da54fa86:-7f7b)


t-owl-rstr:ObjectUnionOf(:xRestriction, &lt;:item1,:item2&gt;) ::
    t-owl-atom:TypedListRelation(:xRestriction, owl:Class, owl:unionOf, &lt;:item1,:item2&gt;)


http://example.org/BurgerMeal(:subject, &lt;:sides&gt;) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fa8, &lt;:sides&gt;)
    t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasMain, ex:Burger)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasSide, -48c2c56f:163da54fa86:-7fa8)


http://example.org/Burger(:subject, &lt;:condiments&gt;, &lt;label&gt;, prefLabel : ?, definition : ?) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-rdf:Triple(:subject, skos:definition, definition)
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7f93, &lt;:condiments&gt;)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, -48c2c56f:163da54fa86:-7f93)


t-owl-axiom:SubObjectSomeValuesFrom(:xClass, :xProperty, :xRange) ::
    t-owl-axiom:SubClassOf(:xClass, -48c2c56f:163da54fa86:-7fef)
    t-owl-rstr:ObjectSomeValuesFrom(-48c2c56f:163da54fa86:-7fef, :xProperty, :xRange)


t-owl-axiom:SubClassOf(:xSubClass, :xSuperClass) ::
    t-rdf:Triple(:xSubClass, rdf:type, owl:Class)
    t-rdf:Triple(:xSuperClass, rdf:type, owl:Class)
    t-rdf:Triple(:xSubClass, rdfs:subClassOf, :xSuperClass)


http://draft.ottr.xyz/pizza/NamedPizza(:pizza, &lt;:toppings&gt;) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fd6, &lt;:toppings&gt;)
    t-owl-axiom:SubClassOf(:pizza, p:NamedPizza)
    t-owl-axiom:SubObjectAllValuesFrom(:pizza, p:hasTopping, -48c2c56f:163da54fa86:-7fd6)
    x | t-owl-axiom:SubObjectSomeValuesFrom(:pizza, p:hasTopping, &lt;:toppings&gt;)


http://draft.ottr.xyz/pizza/Annotation(:subject, &lt;label&gt;, prefLabel, definition) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)
    t-rdf:Triple(:subject, skos:definition, definition)


http://draft.ottr.xyz/pizza/AnnotatedPizza(:subject, &lt;label&gt;, prefLabel : ?, definition : ?) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-rdf:Triple(:subject, skos:definition, definition)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)
    t-owl-axiom:SubClassOf(:subject, p:Pizza)

Checking for redundancy...  Done
Following redundancies found:

======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-axiom:SubObjectAllValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza
	http://example.org/BurgerMeal

===~Suggested templates~===

[name36_0](:subject, :hasCondiment, &lt;:condiments&gt;) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7f93, &lt;:condiments&gt;)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, -48c2c56f:163da54fa86:-7f93)

[name36_2](:subject, &lt;:sides&gt;, :hasSide, :hasMain, ex:Burger) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fa8, &lt;:sides&gt;)
    t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasMain, ex:Burger)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasSide, -48c2c56f:163da54fa86:-7fa8)

===~Lack of reuse~===

http://example.org/Burger has a lack of reuse of http://example.org/BurgerMeal
http://draft.ottr.xyz/pizza/NamedPizza has a lack of reuse of http://example.org/BurgerMeal

======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-axiom:SubObjectAllValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name68_0](:subject, :hasCondiment, &lt;:condiments&gt;, ex:Burger) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7f93, &lt;:condiments&gt;)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, -48c2c56f:163da54fa86:-7f93)

===~Lack of reuse~===

http://example.org/Burger has a lack of reuse of http://draft.ottr.xyz/pizza/NamedPizza

======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-axiom:SubObjectAllValuesFrom:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name41_0](:subject, :hasCondiment, ex:Burger, &lt;:condiments&gt;, -48c2c56f:163da54fa86:-7f93) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, -48c2c56f:163da54fa86:-7f93)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectAllValuesFrom:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name10_1](p:hasTopping, p:NamedPizza, -48c2c56f:163da54fa86:-7fd6, :pizza) ::
    t-owl-axiom:SubClassOf(:pizza, p:NamedPizza)
    t-owl-axiom:SubObjectAllValuesFrom(:pizza, p:hasTopping, -48c2c56f:163da54fa86:-7fd6)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectAllValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name42_1](p:hasTopping, p:NamedPizza, :pizza, &lt;:toppings&gt;) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fd6, &lt;:toppings&gt;)
    t-owl-axiom:SubClassOf(:pizza, p:NamedPizza)
    t-owl-axiom:SubObjectAllValuesFrom(:pizza, p:hasTopping, -48c2c56f:163da54fa86:-7fd6)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectSomeValuesFrom:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name11_1](p:hasTopping, &lt;:toppings&gt;, p:NamedPizza, :pizza) ::
    t-owl-axiom:SubClassOf(:pizza, p:NamedPizza)
    x | t-owl-axiom:SubObjectSomeValuesFrom(:pizza, p:hasTopping, &lt;:toppings&gt;)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	skos:definition:1
	rdfs:label:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name75_0](:subject, prefLabel : ?, definition : ?, &lt;label&gt;, ex:Burger) ::
    t-rdf:Triple(:subject, skos:definition, definition)
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)

===~Lack of reuse~===

http://example.org/Burger has a lack of reuse of http://draft.ottr.xyz/pizza/AnnotatedPizza

======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name12_0](:subject, &lt;:condiments&gt;, ex:Burger, -48c2c56f:163da54fa86:-7f93) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7f93, &lt;:condiments&gt;)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	rdfs:label:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name13_0](:subject, ex:Burger, &lt;label&gt;) ::
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza

===~Suggested templates~===

[name45_1](p:hasTopping, &lt;:toppings&gt;, p:NamedPizza, -48c2c56f:163da54fa86:-7fd6, :pizza) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fd6, &lt;:toppings&gt;)
    t-owl-axiom:SubClassOf(:pizza, p:NamedPizza)
    x | t-owl-axiom:SubObjectSomeValuesFrom(:pizza, p:hasTopping, &lt;:toppings&gt;)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	skos:definition:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name14_1](p:Pizza, :subject, definition : ?) ::
    t-rdf:Triple(:subject, skos:definition, definition)
    t-owl-axiom:SubClassOf(:subject, p:Pizza)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name15_0](:subject, prefLabel : ?, ex:Burger) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-axiom:SubObjectAllValuesFrom:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza
	http://example.org/BurgerMeal

===~Suggested templates~===

[name18_0](:subject, :hasCondiment, &lt;:condiments&gt;, -48c2c56f:163da54fa86:-7f93) ::
    x | t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasCondiment, &lt;:condiments&gt;)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasCondiment, -48c2c56f:163da54fa86:-7f93)

[name18_2](:subject, :hasSide, :hasMain, -48c2c56f:163da54fa86:-7fa8, ex:Burger) ::
    t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasMain, ex:Burger)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasSide, -48c2c56f:163da54fa86:-7fa8)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	skos:definition:1
	rdfs:label:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name50_1](p:Pizza, :subject, definition : ?, &lt;label&gt;) ::
    t-rdf:Triple(:subject, skos:definition, definition)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)
    t-owl-axiom:SubClassOf(:subject, p:Pizza)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubObjectAllValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza
	http://example.org/BurgerMeal

===~Suggested templates~===

[name19_2](:subject, :hasSide, &lt;:sides&gt;) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fa8, &lt;:sides&gt;)
    t-owl-axiom:SubObjectAllValuesFrom(:subject, :hasSide, -48c2c56f:163da54fa86:-7fa8)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	rdfs:label:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name51_0](:subject, prefLabel : ?, &lt;label&gt;, ex:Burger) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-owl-axiom:SubClassOf(:subject, ex:Burger)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubObjectSomeValuesFrom:1
	t-owl-rstr:ObjectUnionOf:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/NamedPizza
	http://example.org/BurgerMeal

===~Suggested templates~===

[name22_2](:subject, &lt;:sides&gt;, :hasMain, -48c2c56f:163da54fa86:-7fa8, ex:Burger) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fa8, &lt;:sides&gt;)
    t-owl-axiom:SubObjectSomeValuesFrom(:subject, :hasMain, ex:Burger)

[name22_1](p:hasTopping, -48c2c56f:163da54fa86:-7fd6, :pizza, &lt;:toppings&gt;) ::
    t-owl-rstr:ObjectUnionOf(-48c2c56f:163da54fa86:-7fd6, &lt;:toppings&gt;)
    x | t-owl-axiom:SubObjectSomeValuesFrom(:pizza, p:hasTopping, &lt;:toppings&gt;)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	t-owl-axiom:SubClassOf:1
	skos:definition:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name54_1](p:Pizza, prefLabel : ?, :subject, definition : ?) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-rdf:Triple(:subject, skos:definition, definition)
    t-owl-axiom:SubClassOf(:subject, p:Pizza)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	skos:definition:1
	rdfs:label:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/Annotation
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name27_2](:subject, definition : ?, &lt;label&gt;) ::
    t-rdf:Triple(:subject, skos:definition, definition)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	rdfs:label:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/Annotation
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name28_2](prefLabel : ?, &lt;label&gt;, :subject) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	skos:definition:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/Annotation
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name31_2](prefLabel : ?, :subject, definition : ?) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    t-rdf:Triple(:subject, skos:definition, definition)


======================================
==========~Dependency Pair~===========
======================================

Pattern
	skos:definition:1
	rdfs:label:1
	skos:prefLabel:1
occurs in
	http://example.org/Burger
	http://draft.ottr.xyz/pizza/Annotation
	http://draft.ottr.xyz/pizza/AnnotatedPizza

===~Suggested templates~===

[name63_1](:subject, prefLabel, definition, &lt;label&gt;) ::
    t-rdf:Triple(:subject, skos:prefLabel, prefLabel)
    x | t-rdf:Triple(:subject, rdfs:label, &lt;label&gt;)
    t-rdf:Triple(:subject, skos:definition, definition)

===~Lack of reuse~===

http://example.org/Burger has a lack of reuse of http://draft.ottr.xyz/pizza/Annotation
http://draft.ottr.xyz/pizza/AnnotatedPizza has a lack of reuse of http://draft.ottr.xyz/pizza/Annotation
</pre>

</div>
</div>
</div>

<div id="outline-container-org5d3b1c7" class="outline-2">
<h2 id="org5d3b1c7"><span class="section-number-2">9</span> Script</h2>
<div class="outline-text-2" id="text-9">
<p>
All the executable examples may be run with the script <code>run.sh</code>, this is its contents:
</p>

<div class="org-src-container">
<pre class="src src-sh">## write commands too
set -x
printf "\n\n\n"


## download jar files
if [ ! -f ./lutra.jar ];
then
  wget https://gitlab.com/ottr/lutra/lutra/builds/artifacts/v0.1.6/raw/lutra.jar?job=build_tags -O lutra.jar
fi

if [ ! -f ./findPatterns.jar ];
then
  wget http://folk.uio.no/martige/what/20180601/findPatterns.jar -O findPatterns.jar
fi
printf "\n\n\n"


## display CLI
java -jar lutra.jar
printf "\n\n\n"


## convert to stOTTR serialisation
java -jar lutra.jar -stottr -in tpl/intro/SubClassOf1
printf "\n\n\n"


## expand instances
java -jar lutra.jar -expand -in inst/intro/SubClassOf1Instances
printf "\n\n\n"


## expand template definition
java -jar lutra.jar -expand -in tpl/intro/SubClassOf1
printf "\n\n\n"


## types: stOTTR serialisation
java -jar lutra.jar -stottr -in tpl/types/SubClassOf3.ttl -out tpl/types/SubClassOf3.ttl.stottr
cat tpl/types/SubClassOf3.ttl.stottr
printf "\n\n\n"


## type check
java -jar lutra.jar -expand -lib tpl/types -in inst/types/SubClassOf3Instances -out inst/types/SubClassOf3Instances.out
printf "\n\n\n"


## type expansion
cat inst/types/SubClassOf3Instances.out
printf "\n\n\n"


## type error
java -jar lutra.jar -expand -lib tpl/types -in inst/types/SubClassOf3Instances2
printf "\n\n\n"


## cardinality: optional
java -jar lutra.jar -expand -in inst/card/ResourceDescriptionInstances
printf "\n\n\n"


## cardinality: multiple
java -jar lutra.jar -expand -in inst/card/EquivObjectUnionOfInstances
printf "\n\n\n"


## mode test1
java -jar lutra.jar -quiet -expand -lib tpl/mode -in tpl/mode/SubClassOf1Instances
printf "\n\n\n"


## mode test2
java -jar lutra.jar -quiet -expand -lib tpl/mode -in tpl/mode/SubClassOf2Instances
printf "\n\n\n"


## mode test3
java -jar lutra.jar -quiet -expand -lib tpl/mode -in tpl/mode/SubClassOf3Instances
printf "\n\n\n"


## pizza stottr
java -jar lutra.jar -stottr -in http://draft.ottr.xyz/pizza/NamedPizza
printf "\n\n\n"


## pizza instances
java -jar lutra.jar -expand -in tpl/pizza/NamedPizzaInstances
printf "\n\n\n"


## pizza tabOTTR
java -jar lutra.jar -tabottr -in tab/NamedPizza-instances.xlsx
printf "\n\n\n"


## find redundancies, restricted to demo-paper patterns
java -jar findPatterns.jar -p redundancy-templates/
printf "\n\n\n"


## find redundancies, all
java -jar findPatterns.jar -p redundancy-templates/
printf "\n\n\n"
</pre>
</div>

</div> <!-- end toc-content -->
</div> <!-- end right -->
</div>
</div>
</div>
</body>
</html>
